package app2;

import java.io.DataOutputStream;
import java.io.DataInputStream;
import java.util.Hashtable;
import java.util.Enumeration;
import app2.NewPlayer;
import app2.UpdatePlayer;
import app2.Delay;


public class CustomTypes { 
	 public void encodeNewPlayer(DataOutputStream dos,NewPlayer customType) throws Exception { 
		 dos.writeShort(customType.getId());
		 dos.writeInt(customType.getX());
		 dos.writeInt(customType.getY());
		 dos.writeUTF(customType.getUsername());

	 }

	 public void encodeUpdatePlayer(DataOutputStream dos,UpdatePlayer customType) throws Exception { 
		 dos.writeShort(customType.getId());
		 dos.writeInt(customType.getX());
		 dos.writeInt(customType.getY());
		 dos.writeInt(customType.getSpeedX());
		 dos.writeInt(customType.getSpeedY());
		 dos.writeInt(customType.getPathPtr());

		 int[] table1= customType.getPathX();
		 int table1_l0 = table1.length;
		 dos.writeShort((short) table1_l0);
		 for(int i0=0; i0<table1_l0; i0++){
			 dos.writeInt(table1[i0]);
		}

		 int[] table2= customType.getPathY();
		 int table2_l0 = table2.length;
		 dos.writeShort((short) table2_l0);
		 for(int i0=0; i0<table2_l0; i0++){
			 dos.writeInt(table2[i0]);
		}

	 }

	 public void encodeDelay(DataOutputStream dos,Delay customType) throws Exception { 
		 dos.writeShort(customType.getId());
		 dos.writeInt(customType.getPing());

	 }

	 public void encodeData(Hashtable h, DataOutputStream dos) throws Exception {
		 dos.writeByte(h.size());
		 int nbSend = h.size();
		 for(int i=0; i<nbSend; i++){
			 Object o  = (Object) h.get(""+i);
			 if (o.getClass().getName().equals("app2.NewPlayer")){
				 dos.writeByte(6);
				 encodeNewPlayer(dos,(NewPlayer) o);
			 }
			 if (o.getClass().getName().equals("app2.UpdatePlayer")){
				 dos.writeByte(7);
				 encodeUpdatePlayer(dos,(UpdatePlayer) o);
			 }
			 if (o.getClass().getName().equals("app2.Delay")){
				 dos.writeByte(8);
				 encodeDelay(dos,(Delay) o);
			 }
		}
	}
	 public NewPlayer decodeNewPlayer(DataInputStream dis) throws Exception { 
		 NewPlayer customType = new NewPlayer();
		 customType.setId(dis.readShort()); 
		 customType.setX(dis.readInt()); 
		 customType.setY(dis.readInt()); 
		 customType.setUsername(dis.readUTF()); 

		 return customType;
	 }

	 public UpdatePlayer decodeUpdatePlayer(DataInputStream dis) throws Exception { 
		 UpdatePlayer customType = new UpdatePlayer();
		 customType.setId(dis.readShort()); 
		 customType.setX(dis.readInt()); 
		 customType.setY(dis.readInt()); 
		 customType.setSpeedX(dis.readInt()); 
		 customType.setSpeedY(dis.readInt()); 
		 customType.setPathPtr(dis.readInt()); 

		 int[] table1;
		 short table1_l0 = dis.readShort();
		 table1 = new int[table1_l0];
		 for(int i0=0; i0<table1_l0; i0++){
			 table1[i0]= dis.readInt();
		}
		 customType.setPathX(table1);

		 int[] table2;
		 short table2_l0 = dis.readShort();
		 table2 = new int[table2_l0];
		 for(int i0=0; i0<table2_l0; i0++){
			 table2[i0]= dis.readInt();
		}
		 customType.setPathY(table2);

		 return customType;
	 }

	 public Delay decodeDelay(DataInputStream dis) throws Exception { 
		 Delay customType = new Delay();
		 customType.setId(dis.readShort()); 
		 customType.setPing(dis.readInt()); 

		 return customType;
	 }

	 public Hashtable decodeData(DataInputStream dis) throws Exception {
		 Hashtable h = new Hashtable();
		 byte nb = dis.readByte();
		 int nbObj = nb;
		 while(nb!=0){
			 String key = ""+(nbObj - nb);
			 byte type = dis.readByte();
			 if (type == 6){
				 NewPlayer customType = decodeNewPlayer(dis);
				 h.put(key,customType);
			 }
			 else if (type == 7){
				 UpdatePlayer customType = decodeUpdatePlayer(dis);
				 h.put(key,customType);
			 }
			 else if (type == 8){
				 Delay customType = decodeDelay(dis);
				 h.put(key,customType);
			 }
			 nb--;
		}
		 return h;
	}
}//CustomTypes