/***
 * GASP: a gaming services platform for mobile multiplayer games.
 * MooDS: a communication protocol used in GASP.
 * GASP Demonstrator: a gasp demonstration game.
 *
 * Copyright (C) 2004 CNAM/INT
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: gasp-team@objectweb.org
 *
 * Author: Franck Caron, Romain Pellerin
 */
/*
 * Created on 2 december 2005
 *
 * @author CARON Franck - CNAM CEDRIC
 * @author PELLERIN Romain - CNAM CEDRIC
 * 
 * 
 * Research project: CNAM-CEDRIC - INT - Filao
 */
//#include parameters.h
////#define DEMO
////#define VERSION_SOLO
////#define FRANCK

//#endinclude

/*
 * Created on 15 fvr. 200
 * 
 */

package app2.server;

/**
 * @author PELLERIN Romain (CNAM Paris, romain.pellerin@laposte.net)
 * 
 * @author DELPIANO Fabien (Pastagames, fabien@pastaga.net)
 * @author KOCIK Fabrice - (Pastagames, fabrice@pastis.org)
 * @author CARON Franck (CNAM Paris)
 * --
 * JIMM Project 2005
 * (Bouygues Telecom, CNAM Paris, Pastagames)
 */

import java.util.*;

public class Player {
    
    private int id;
    private int x;
    private int y;
    private int speedX,speedY;
    
    // Delay-related messages
    private int ping;
    private long tPingUpdate;
    private HashSet pingReaders=new HashSet();
    
    private String username;
    
    public int maxActor;
    
    public Player(int _id, String _username){
        id = _id;
        username = _username;
     }
    
    public Player(int _id){
        id = _id; 
     }
    /*******************************/
    /** Informations for the game **/
    /*******************************/
    
    public int getId(){return id;}
	public void setId(int id1){id=id1;}
    
    public int getX(){return x;}
    public void setX(int x1){x=x1;}
        
    public int getY(){return y;}
    public void setY(int y1){y=y1;}

    public String getUsername(){return username;}
    public void setUsername(String _username){username=_username;}

    public void setPing(int ping)
    {
      this.ping=ping;
      tPingUpdate=System.currentTimeMillis();
      pingReaders.clear(); // no reader has yet read that
    }
    
    public boolean isPingFresh(int readerNo)
    {
      return !pingReaders.contains(new Integer(readerNo));
    }
    
    public int readPing(int reader)
    {
      pingReaders.add(new Integer(reader));
      return (int)(ping+System.currentTimeMillis()-tPingUpdate);
    }
    
    public int getSpeedX() {
		return speedX;
	}

	public void setSpeedX(int speedX) {
		this.speedX = speedX;
	}

	public int getSpeedY() {
		return speedY;
	}

	public void setSpeedY(int speedY) {
		this.speedY = speedY;
	}
 
}
